classdef eCuboid < eGeometric_Primitive
    %CYLINDRICAL_Object descirbes cylindrical element
    % geometry.cornerx=2;  % x corner of cuboid
    % geometry.cornery=3;  % y corner of cuboid
    % 
    % geometry.cornerz=4;  % z corner of cuboid
    % geometry.sizex=2;
    % 
    % geometry.sizey=2;
    % geometry.sizez=2;
    % 
    % ce=eCuboid(geometry);
    % surface_color=[0.2 0.3 0.5];
    % edge_color=[0.1 0.9 0.6];
    % alpha=0.5;
    % ce.sketch(surface_color,edge_color,alpha);
    
    % constructor 
        % geometry.cornerx=  % x corner of cuboid
        % geometry.cornery=  % y corner of cuboid
        % 
        % geometry.cornerz=  % z corner of cuboid
        % geometry.sizex=
        % 
        % geometry.sizey=
        % geometry.sizez=
        % 
    
    properties (SetAccess='public')
        %sketch_data % points which descibes only border points od element
        %geometry
        % geometry.cornerx=  % x corner of cuboid
        % geometry.cornery=  % y corner of cuboid
        % 
        % geometry.cornerz=  % z corner of cuboid
        % geometry.sizex=
        % 
        % geometry.sizey=
        % geometry.sizez=
        % 

    end
    
    methods (Access='public')
        
        function CE_obj = eCuboid(varargin)
        %sketch_data % points which descibes only border points od element
        %geometry
        % geometry.cornerx=  % x corner of cuboid
        % geometry.cornery=  % y corner of cuboid
        % 
        % geometry.cornerz=  % z corner of cuboid
        % geometry.sizex=
        % 
        % geometry.sizey=
        % geometry.sizez=
        %     
        
          if nargin > 0 ; % no input arguments
          if isa(varargin{1},'eCuboid')
            CE_obj = varargin{1}; % copy constructor
            display 'Copy constructor eCuboid'
            return;                     
          else
               switch(nargin)
                   
                case 1,   
                
                if(strcmp(varargin{1},'wizard'))
                    
                    CE_obj.wizard(); %set geometry from input

                else
                    
                    CE_obj.geometry=varargin{1};
                    
                end     

               otherwise,
                         error('Too less or too much input elements');
               end % switch
          end
          end
        
        end % constructor
    
        % display sketch of the object, set color of the object
        % e.g. 
        % color.r=0; 
        % color.g=0.5;
        % color.b=0.6; 
        % return plots handle
        [h_plot]=sketch(varargin);        
        
        % chech if given pointS (x,y,z) is a part of object. Margin is
        % for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
        [stts]= check_if_point_belongs_to_object( varargin )
        
        [stts]= check_if_point_belongs_to_object_cuboid( varargin )
        % check if given (single) point belongs to object
        
        %return smallest object thick in each dimension (x, y, z)
        [xyz_thick]=get_smallest_thick(varargin)
        
        % return bounding values xmin, xmax etc
        % [xmin xmax  ymin ymax  zmin zmax ]
        [bounding_box_xyz]=get_bounding_box(varargin)
        
        

    end % methods
    
    methods (Access='private')
        
        function wizard(ec_obj)
            
            in=input('x coordinate corner (left down) of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.cornerx=str2double(in);
            
            %next val
            
            in=input('y coordinate corner (left down) of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.cornery=str2double(in);
            
            %next val
            
            in=input('z coordinate corner (left down) of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.cornerz=str2double(in);
            
            %next val
            
            in=input('size x of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.sizex=str2double(in);
            
            %next val
            
            in=input('size y of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.sizey=str2double(in);
            
            %next val
            
            in=input('size z of cuboid [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.sizey=str2double(in);
            
            %next val
            
        end
    end  
    
end % class    


                

