function [h_plot] = sketch( varargin )
%SKETCH draw sketch of element 
% input color structure color.r=0.5 etc
% represents color of object. R,G,B must be in <0,1> range

this=varargin{1};

if nargin==1
    
    % default    
    
    %if graphics object is set
    if isa(this.graphics,'eGraphics')
        this.geometry.sketch(this.graphics);    
    else
        this.geometry.sketch();
    end
end        
if nargin==2
    
    if isa(varargin{2},'eGraphics')
        gr = varargin{2}; 
        
        this.geometry.sketch(gr);
    end

end

h_plot=gcf;

end

