function [bounding_box_xyz]=get_bounding_box(varargin) 
% return bounding values xmin, xmax etc
% [xmin xmax  ymin ymax  zmin zmax ]
        
this=varargin{1};

x=this.sketch_data.x;
y=this.sketch_data.y;
z=this.sketch_data.z;

xmin=min(min(x));
xmax=max(max(x));
ymin=min(min(y));
ymax=max(max(y));
zmin=min(min(z));
zmax=max(max(z));

bounding_box_xyz=[xmin xmax  ymin ymax  zmin zmax ];

end