function [point_list_of_volume]=get_point_list_of_volume(varargin)
% input: volume size in milimeters (size must be less or equal to current mesh size)
% e.g. [x_mm_min x_mm_max y_mm_min y_mm_max z_mm_min z_mm_max]
% you can use it after at least one object have been meshed 
% return point list of specific volume size

this=varargin{1};
volume_x_y_z_mm=varargin{2};

%   x_mm=this.x_mm_cube_corners;
%   y_mm=this.y_mm_cube_corners;
%   z_mm=this.z_mm_cube_corners;
  
  
  % get bounding box
   
    minxo=volume_x_y_z_mm(1);
    maxxo=volume_x_y_z_mm(2);
    minyo=volume_x_y_z_mm(3); 
    maxyo=volume_x_y_z_mm(4); 
    minzo=volume_x_y_z_mm(5); 
    maxzo=volume_x_y_z_mm(6);
  
       
 
 XX=reshape(this.X_disp,1,numel(this.X_disp));
 YY=reshape(this.Y_disp,1,numel(this.Y_disp));
 ZZ=reshape(this.Z_disp,1,numel(this.Z_disp));
 
 fx1=find(XX<=maxxo);
fx2=find(XX>=minxo);

samex=intersect(fx1,fx2);

fy1=find(YY<=maxyo);
fy2=find(YY>=minyo);

samey=intersect(fy1,fy2);


fz1=find(ZZ<=maxzo);
fz2=find(ZZ>=minzo);

samez=intersect(fz1,fz2);

samexy=intersect(samex,samey);
point_list_of_volume=intersect(samexy,samez);

% iidx to XX YY ZZ point list
% point_list_of_volume=find(minxo<XX<maxxo | minyo<YY<maxyo | minzo<ZZ<maxzo );  
    
%     % check beetween which mm values is object point_mm
%     % return matrix indicies
%    
% %     obj_minx_matrix_subscript=2;
% %     
% %     obj_maxx_matrix_subscript=4;
% %     
% %     
% %     obj_miny_matrix_subscript=2;
% %     
% %     obj_maxy_matrix_subscript=4;
% %     
% %     
% %     obj_minz_matrix_subscript=2;
% %     
% %     obj_maxz_matrix_subscript=4;
%     
%     
%     obj_minx_matrix_subscript=max(find(x_mm<obj_minx));
%     
%     obj_maxx_matrix_subscript=max(find(x_mm<obj_maxx));
%     
%     
%     obj_miny_matrix_subscript=max(find(y_mm<obj_miny));
%     
%     obj_maxy_matrix_subscript=max(find(y_mm<obj_maxy));
%     
%     
%     obj_minz_matrix_subscript=max(find(z_mm<obj_minz));
%     
%     obj_maxz_matrix_subscript=max(find(z_mm<obj_maxz));
%     
% %     hold on
% %     plot3(obj_minx,obj_miny,obj_minz,'ro');
% %     plot3(obj_maxx,obj_maxy,obj_maxz,'ro');
%     
%     %size_discrete_xyz=this.size_discrete_xyz;
%     
% 
%      % contains values of subscript of cube_point_list_and_vertices
%      %point_list_x=sub2ind(size_discrete_xyz,obj_minx_matrix_subscript,obj_miny_matrix_subscript,obj_minz_matrix_subscript);
%      %this.show_elements(point_list_x);
%     
%     
%     %[obj_minx_matrix_subscript obj_maxx_matrix_subscript]
%     %[obj_miny_matrix_subscript obj_maxy_matrix_subscript]
%     %[obj_minz_matrix_subscript obj_maxz_matrix_subscript]
%     
%     %point_list_y=sub2ind(size_discrete_xyz,obj_maxx_matrix_subscript,obj_maxy_matrix_subscript,obj_maxz_matrix_subscript);
%     % this.show_elements(point_list_y)
%     
%     
%     % generate vectors of volume object where is object
%     x_subscript_vector=linspace(obj_minx_matrix_subscript,obj_maxx_matrix_subscript,obj_maxx_matrix_subscript-obj_minx_matrix_subscript+1);
%     
%     y_subscript_vector=linspace(obj_miny_matrix_subscript,obj_maxy_matrix_subscript,obj_maxy_matrix_subscript-obj_miny_matrix_subscript+1);
%     
%     z_subscript_vector=linspace(obj_minz_matrix_subscript,obj_maxz_matrix_subscript,obj_maxz_matrix_subscript-obj_minz_matrix_subscript+1);
%     
%     %[xsi ysi zsi]=ndgrid(x_subscript_vector,y_subscript_vector,z_subscript_vector);
%     [xsi ysi zsi]=meshgrid(x_subscript_vector,y_subscript_vector,z_subscript_vector);
%     
%     
%     size_discrete_xyz=this.size_discrete_xyz;
%     
%     xs=reshape(xsi,1,numel(xsi));
%     ys=reshape(ysi,1,numel(ysi));
%     zs=reshape(zsi,1,numel(zsi));
%             
% %     hold on
% %     plot3(xs,ys,zs,'ro')
%     
%     % contains values of subscript of cube_point_list_and_vertices
%     point_list_of_volume=sub2ind(size_discrete_xyz,xs,ys,zs);
%     %this.show_elements(point_list_of_volume)

end

