function [bounding_box_xyz]=get_bounding_box(varargin) 
% return bounding values xmin, xmax etc
% [xmin xmax ymin ymax zmin zmax ]

this=varargin{1};

x1=this.sketch_data.x1; % two rows
x1=reshape(x1,[1 numel(x1)]); % convert to one row

x2=this.sketch_data.x2;
x2=reshape(x2,[1 numel(x2)]);

x3=this.sketch_data.x3;
x3=reshape(x3,[1 numel(x3)]);

x4=this.sketch_data.x4;
x4=reshape(x4,[1 numel(x4)]);

x=[x1 x2 x3 x4]; %concatenating rows

min_x_dimension=min(x);
max_x_dimension=max(x);

% *****************
y1=this.sketch_data.y1; % two rows
y1=reshape(y1,[1 numel(y1)]); % convert to one row

y2=this.sketch_data.y2;
y2=reshape(y2,[1 numel(y2)]);

y3=this.sketch_data.y3;
y3=reshape(y3,[1 numel(y3)]);

y4=this.sketch_data.y4;
y4=reshape(y4,[1 numel(y4)]);

y=[y1 y2 y3 y4]; %concatenating rows

min_y_dimension=min(y);
max_y_dimension=max(y);

%***********************

max_z_dimension  = this.geometry.h_high;
min_z_dimension  = this.geometry.h_low;

bounding_box_xyz=[min_x_dimension max_x_dimension min_y_dimension max_y_dimension min_z_dimension max_z_dimension];

end

