function [point_lists]=assign_mesh_points(varargin)
% set point list using given Mesh
% input Mesh
% output: pointlist point_list_and_vertices
% this values are also set in eElement object automatically

this=varargin{1};
mesh=varargin{2};        
geometry=this.geometry;

[pointlist point_list_and_vertices]=mesh.set_geometry_object(geometry);

this.point_list=pointlist;
this.point_list_and_vertices=point_list_and_vertices;

point_lists{1}=pointlist;
point_lists{2}=point_list_and_vertices;

end