function id=get_id(varargin)
% get id of elements belongs to set with set name id=eset_obj.get_id(name)
% name must be string or cell string array
% id=eset_obj.get_id('rod') or id=eset_obj.get_id({'rod','electrode'})
      
this=varargin{1};
name=varargin{2};
idind=0;

if iscellstr(name)
else
    %if not create cell str
     name = cellstr(name);
end
   
cel_len=length(name);

for j=1:cel_len
    
    key=keys(this.element_map);        

    w=cell2mat(key(:));

    ln=length(w);    
    % map doesn't support vectors...

    for i=1:ln
    tmp_element=this.element_map(w(i));
        if strcmp(tmp_element.name,name(j))
            idind=idind+1;
            id(idind)=tmp_element.element_id;                    
        end
    end
end
end

