function [FP]= compute_fp(EF,mesh,point_list,permittivity_3d_matrix)
% input (mesh,point_list,permittivity,boundary,neighbours_pidx,neighbours_iidx,potential_maps,point_list_from_where_get_sensitivity)
% point_list_from_where_get_sensitivity (only point outside of electrodes (boundary condition) should be taken)
% return FP (with sensitivity and capacitance)

FP=eFwd_Problem(mesh,EF.potential_maps_3d_matrix,permittivity_3d_matrix,point_list);

FP.compute_S_map();

end

